



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>跨平台 webapp 开发技术之 Hybrid App</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">跨平台 webapp 开发技术之 Hybrid App</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-21 20:44:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>前所知的 APP 开发模式有三种：</p>
<ol><li>基于操作系统运行的 APP -&gt; Native App，侧重于原生开发，用户体验好，需要安装才会升级</li>
<li>基于浏览器运行的 APP -&gt; Web App，侧重于网页技术实现，跨平台兼容性好，只要开发人员更新代码，无需通过安装升级</li>
<li>基于移动应用引擎 -&gt;&nbsp;Hybrid App，使用H5和JS开发。如果不追求用户体检时，这种方式最快也最省钱</li></ol>
<p>下面的图摘自简书，是对三种不同形态的 APP 的对比：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/868284/201803/868284-20180308230729525-1129090002.png" /></p>
<p>Hybrid APP是目前广泛流行的一种APP开发模式，Android、iOS、JS三端内容初步都已经完成，有完善的设计思路、教程以及API文档。</p>
<p>Hybrid App，这种既有<code>跨平台开发周期短</code>、<code>成本低的基因</code>，又<code>能发挥Native App体验和性能</code>的优势，HybridApp混合式移动应用开发逐渐成为企业移动开发的首选。<br />Hybrid App通常是<code>基于第三方跨平台移动应用引擎框架</code>进行开发：</p>
<p>在国内开发者中比较知名的有<code>PhoneGap、Titanium和AppCan这些引擎框架</code>一般使用<code>HTML5和Javascript</code>作为编程语言，调用<code>引擎封装的底层功能如照相机、传感器、通讯录、二维码</code>等。<code>HTML5和Javascript只是作为一种解析语言，真正调用的都是NativeApp一样封装的底层功能，这是和Web App的最大区别和不同</code>。因为使用了<code>浏览器技术</code>，所以Hybrid App通常具有<code>跨平台的特性</code>，并且<code>开发成本和WebApp接近</code>，开发<code>效率也远高于Native App</code>。</p>
<p>说实在的，从表面上看的话，很难区分一个App到底是Native App还是Hybrid App，但实际上我们更多的是把<code>Hybrid App当做是Webapp的一部分</code>，因为他是一部分Native（比较少），绝大部分的web页面（html5页面）。</p>
<p>Hybrid App和Native App一样都是需要用户在各种App分发渠道上<code>下载并安装到手机上才能用的</code>。Hybrid App的体验当然是没话说，比较棒的，有这Native App的全部优点。html5很好的解决了跨平台性的问题，也解决了开发成本过高的问题。</p>
<p>国内外Hybrid App的开发平台众多，目前有三种开发模式：</p>
<ol><li>使用PhoneGap、AppCan之类的中间件，以WebView作为用户界面层，以JavaScript作为基本逻辑，以及和中间件通讯，再由中间件访问底层API的方式，进行应用开发。这种架构一般会非常依赖WebView层的性能。</li>
<li>使用Adobe Air、RubyMotion、Appcelerator或者是Xamarin这种非官方语言的工具，打包成原生应用的方式开发。为什么笔者会将它们定义为Hybrid App，主要是它们并没有很单纯地使用原生提供的语言进行开发，而是通过对开发者提供友好的开发工具，并折中地把这种开发语言转换成原生语言，最终打包出整个应用，所以也属于混合应用范畴。</li>
<li>在开发原生应用的基础上，嵌入WebView但是整体的架构使用原生应用提供，一般这样的开发由Native开发人员和Web前端开发人员组成。Native开发人员会写好基本的架构以及API让Web开发人员开发界面以及大部分的渲染。保证到交互设计，以及开发都有一个比较折中的效果出来，优化得好也会有很棒的效果。</li></ol>
<h2><strong>国内&nbsp;Hybrid App 框架，比较多：</strong></h2>
<h3><a href="http://www.dcloud.io/" rel="external nofollow noreferrer">dcloud</a></h3>
<p>成立时间：2014年</p>
<p>融资情况：1200万人民币</p>
<p>产品：hbuilder、5+runtime、mui（免费）</p>
<p>集成的原生sdk：通过5＋sdk自行集成</p>
<h3><a href="https://www.phonegap.com/" rel="external nofollow noreferrer">phonegap(Cordova)</a></h3>
<p>成立时间：2008年8月</p>
<p>融资情况：已被adobe收购</p>
<p>产品：phonegap(cordova)</p>
<p>集成的原生sdk：自行集成</p>
<p>产品功能：</p>
<p>PhoneGap是一款国外的开源移动开发平台。目前已经将核心代码贡献给Apache cordova，最新版本是2.6.0，它是基于HTML，CSS和JavaScript的，可以使用一些开源的框架比如jQuery Mobile，Dojo Mobile，Sencha Touch等等来提高用户体验，也提供了比较丰富的原生插件调用。</p>
<p>缺点：</p>
<ol><li><p>需要针对相应的平台环境配置，进行编译，打包测试，发布等等。由于使用Hybrid开发的用户群，大部分是web开发者，对原生开发基本不了解，这无疑给每一个开发者增加了沉重的负担，需要对各个平台的开发都要需要了解，对硬件等等都要配置，加大开发成本。</p></li>
<li><p>使用效果启动慢，页面切换响应慢，数据请求慢。调试难度大，内存消耗大。不能完全跨平台，不同平台代码需要微调。</p></li>
<li><p>文档虽比较详细但是基本是英文，对于国内大部分用户英文水平较差的是比较大的挑战。</p></li>
<li><p>因为是国外的框架，技术支持不够到位，出现问题，无法排解，成为技术攻关的难点。</p></li></ol>
<p>侧重点：侧重于对硬件的访问控制</p>
<h3><a href="http://www.appcan.cn/" rel="external nofollow noreferrer">appcan</a></h3>
<p>成立时间：2010年初</p>
<p>融资情况：1亿元人民币</p>
<p>产品：公众版（免费）与企业版（收费）</p>
<p>缺点：</p>
<ol><ol><li><p>虽然有中文的开发文档，但描述比较简单，希望他们丰富他们的API文档。</p></li>
<li><p>免费版本不支持自定义插件（据说企业版可以自定义插件）。</p></li>
<li><p>暂时只支持iOS，Android两大平台，不知道什么时候推出Windows Phone 8？</p></li>
<li><p>许多功能需要企业版才能实现，不过是收费的。</p></li>
<li><p>AppCan免费版因需要把源代码上传到厂商的服务器上打包，对于企业开发来说源代码泄露安全性上有一定风险。企业版虽然可以解决，但企业版稳定尚待观察。</p></li>
<li><p>AppCan采用封装的组件，依赖性比较高。不是开源代码。</p></li>
<li><p>AppCan 不能很好的解决原生代码的功能。</p></li></ol></ol>
<h2>phonegap与appcan什么区别？</h2>
<p>大概浏览了一下appcan的文档，api设计只能用莫名其妙来形容，各种缩写，各种看不懂。</p>
<table>
<thead>
<tr>
<th>比较表格</th>
<th>Phonegap</th>
<th>AppCan</th>
</tr>
</thead>
<tbody>
<tr>
<td>框架功能</td>
<td>简单</td>
<td>丰富</td>
</tr>
<tr>
<td>支持平台</td>
<td>大部分平台</td>
<td>仅4种平台</td>
</tr>
<tr>
<td>开发环境</td>
<td>不同平台需要不同开发环境</td>
<td>只需一个IDE包</td>
</tr>
<tr>
<td>调试</td>
<td>可直接调试</td>
<td>本地发布的IOS包，必须部署在越狱的机器上</td>
</tr>
<tr>
<td>发布</td>
<td>在本地可以直接发布</td>
<td>必须将代码上传至服务器，才能发布</td>
</tr>
<tr>
<td>IOS 签名管理</td>
<td>本地管理</td>
<td>需要上传至服务器</td>
</tr>
<tr>
<td>代码泄露风险</td>
<td>低：仅在本地、svn保存代码</td>
<td>高：需将代码上传至appcan服务器</td>
</tr>
</tbody>
</table>
<h2>Hybrid面临的挑战</h2>
<p>Facebook推出的React Native方案,这是Facebook在放弃h5后自行推出一个'反H5方案',一句话总结就是:里面可以用JS来完整的写一个原生应用。</p>
<p>微信推出的小程序，这也是一个微信主导的'反H5方案',一句话总结就是:里面可以同JS+微信自制的UI方案来写一个类似于原生的应用,只不过这个应用不是发布到App Store中,而是发布到微信中。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96kg64q.html">ubuntu add application to launcher</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7yyljq.html">✡   leetcode 165&period; Compare Version Numbers 比较两个字符串数字的大小  --------- java</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kerg38.html">&period;NET Remoting获取配置通道：</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8evmjj9.html">IOS行货自动打包</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93ey50q.html">开坑，Unix环境高级编程，转行之路又得缓缓了</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o7yl5q.html">Android 中&OpenCurlyDoubleQuote;TabBar&rdquo;的背景拉伸问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k3nz5q.html">高手指南PHP安装配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oknrxp9.html">ASP&period;NET使用后台更改前台Style</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvj7loq.html">&lbrack;EAP&rsqb;将hostapd作为radius服务器搭建EAP认证环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnzojrq.html">Java public&comma; private&comma; protected and default</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1622g8.html">swift Array 数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgz7n48.html">java学习之tcp与udp的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ydne08.html">1227&colon; &lbrack;SDOI2009&rsqb;虔诚的墓主人</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1g52gq.html">Java系列 &ndash; 用Java8新特性进行Java开发太爽了&lpar;续&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jzklw8.html">BZOJ&lowbar;1878&lowbar;&lbrack;SDOI2009&rsqb;HH的项链&lowbar;莫队</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwdy2y8.html">Analysis Services（SSAS） 性能优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvdxkx8.html">【CodeForces 730H】Delete Them</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o5l6j8.html">JS &lowbar;proto&lowbar; 和 prototype</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5ezg4q.html">elasticsearch-ik</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv7l2z8.html">JavaScript -- Window-Confirm</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7z6oex9.html">【Redis篇】初始Redis与Redis安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jo5438.html">&period;NET Core实战项目之CMS 第十七章 CMS网站系统的部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k0re59.html">PHP 编码规范</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zodkl3q.html">C&num;计算一段代码的运行时间</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd0mnk9.html">DDD实战进阶第一波&lpar;一&rpar;：开发一般业务的大健康行业直销系统（概述）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljgozk9.html">一个类是怎么被JVM执行的</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpym369.html">JAVA实现在线查看PDF和office文档</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zrmwe9.html">从0打卡leetcode之day 3 -- 最大子序列和</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k0j269.html">C&num; 反射，通过类名、方法名调用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rge1w78.html">centos6&period;7 配置外网端口映射</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
